#define PIPE_ADDRESS 0xb4b5b600//Set this to your own!! in order to avoid collision.

//Main
//Receiver receives message from the Transmitter and prints it out onto PC.
#include <inttypes.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <stdio.h>

#include "uart.c"//Need for PC interface
                 //Baud rate is set in uart.c file
#include <util/delay.h>


//your_pick and his_pick stores rock(1), paper(2), scisors(3) or stand-by(0);
unsigned char your_pick, his_pick;

// UART file descriptor
// putchar and getchar are in uart.c
FILE uart_str = FDEV_SETUP_STREAM(uart_putchar, uart_getchar, _FDEV_SETUP_RW);
#include "module_api.h"



void main(void){
	unsigned char win_status;//0 = Draw, 1 = win, 2 = Lose
	unsigned char temp8;//temp 8 = 8 bit buffer

	uart_init();
	stdout = stdin = stderr = &uart_str;
	fprintf(stdout,"\n\nStarting New\n");
	init_RF();//Initializes the connection between the RF module and the SPI module of the MCU
	TXmode(1);//setup the RF module as Primary Transmitter
	setup_RF_frequency(1);//RF base frequency is 2400 + 1 = 2.401Ghz
	setup_RF_data_rate(2);//RF data rate is 250Kbps(Slowest)
	setup_auto_retr(0,15);
	set_TX_addr(0xb3,PIPE_ADDRESS);//Address for TX data pipe
	set_RX_addr_P0(0xb3,PIPE_ADDRESS);//Same goes for RX data pipe
	set_payload_legnth(1);//Payload length is 1	
    while(1){
		fprintf(stdout, "Please enter your choice[Rock(1),Paper(2), Scisors(3)]");
		fscanf(stdin, "%d", &your_pick);
		while(your_pick!=1&&your_pick!=2&&your_pick!=2&&your_pick!=3){//User had put in wrong choice
			fprintf(stdout, "Wrong Choice\n");
			fprintf(stdout, "Please enter your choice[Rock(1),Paper(2), Scisors(3)]");
			fscanf(stdin, "%d", &your_pick);
		}
		TX_payload_array[0] = your_pick;
	
		
		//Now send/receive the data
	
		fprintf(stdout, "Waiting for your opponent...\n");
		TXmode(1);		//TX mode
		clear_IRQs();
		flush_TX_FIFO();
		write_TX_payload(0);

		while(1){
			if(check_TX_DS()){
				break;
			}
			if(check_MAX_RT()){
				PORTB &= ~(1<<CE);//turn of transmit mode
				clear_IRQs();
				flush_TX_FIFO();
				write_TX_payload(0);
			}
		}
		
		TXmode(0); //Set the module to PRX mode
		flush_RX_FIFO();
		clear_IRQs();	
		while(1){
			if(check_RX_DR()) break;
		}
		
		read_RX_payload();

		his_pick = RX_payload_array[0];
		fprintf(stdout, "Result:");
		switch(your_pick){
			case 1: fprintf(stdout,"ROCK(yours) vs");	break;
			case 2: fprintf(stdout,"PAPER(yours) vs");	break;
			case 3: fprintf(stdout,"SCISORS(yours) vs");	break;
		}
		switch(his_pick){
			case 1: fprintf(stdout,"ROCK(his)\n");	break;
			case 2: fprintf(stdout,"PAPER(his)\n");	break;
			case 3: fprintf(stdout,"SCISORS(his)\n");	break;
		}
		//Make decision
		switch(your_pick){
			case 1:	//Rock(yours) 
				switch(his_pick){
					case 1: win_status = 0; break; //vs Rock(his)
					case 2: win_status = 2;  break; //vs paper(his)
					case 3: win_status = 1; break; //vs scisors(his)
				}
				break;
			case 2:	//Paper(yours) 
				switch(his_pick){
					case 1: win_status = 1; break; //vs Rock(his)
					case 2: win_status = 0;  break; //vs paper(his)
					case 3: win_status = 2; break; //vs scisors(his)
				}
				break;
			case 3:	//Scisors(yours) 
				switch(his_pick){
					case 1: win_status = 2; break; //vs Rock(his)
					case 2: win_status = 1;  break; //vs paper(his)
					case 3: win_status = 0; break; //vs scisors(his)
				}
				break;
		}
		switch(win_status){
			case 0: fprintf(stdout, "DRAW!!\n"); break;
			case 1: fprintf(stdout, "WIN!!\n"); break;
			case 2: fprintf(stdout, "LOSE!!\n"); break;
		}
		
		fprintf(stdout, "\n");

	}	
}
